SystemOrganization addCategory: #'MonticelloFileDirectory-Base'!
SystemOrganization addCategory: #'MonticelloFileDirectory-Test'!

Object subclass: #McFdCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!McFdCreator methodsFor: 'creation' stamp: 'pe 11/26/2007 12:10'!
createAllForVersion: aVersion at: aDirectory 
	| dirString packageDirectory versionDirectory categoryDirectory |
	
	packageDirectory := self createDirectory: aVersion package name at: aDirectory.
	
	versionDirectory := self createDirectory: aVersion info name at: packageDirectory.
	
	aVersion package packageInfo systemCategories do: [:each | 
		self createDirectory: (self extractCategoryStringFrom: each asString) at: versionDirectory].
	
	self createFilesFrom: aVersion at: versionDirectory! !

!McFdCreator methodsFor: 'creation' stamp: 'pe 11/26/2007 11:51'!
createDirectory: aString at: aDirectory 
	| directory dirString |
	dirString := aDirectory fullName , FileDirectory slash asSymbol , aString.
	directory := FileDirectory on: dirString.
	directory assureExistence.
	^directory.! !

!McFdCreator methodsFor: 'creation' stamp: 'pe 11/26/2007 13:55'!
createFilesFrom: aVersion at: aDirectory
"puts test.txt in every subdirectory for testing"	
	| directory streamForVersionInfo streamForDependencies stream |

		streamForVersionInfo := aDirectory forceNewFileNamed: 'VersionInfo.txt'.
		streamForVersionInfo nextPutAll: (aVersion info)summaryHeader.
		streamForVersionInfo close.
		
		streamForDependencies := aDirectory forceNewFileNamed: 'Dependencies.txt'.
		streamForDependencies nextPutAll: aVersion dependencies..
		streamForDependencies close.


	aVersion snapshot definitions do: [ :each |
		each isClassDefinition ifTrue: [
			directory := self createDirectory: (self extractCategoryStringFrom: each category ) at: aDirectory.
			stream := directory forceNewFileNamed: each className ,'.txt'.
			stream nextPutAll: each source.
			stream close ].
		each isMethodDefinition ifTrue: [
			"Test auf Extentions!!!!!!"
"			directory := self createDirectory: (self extractCategoryStringFrom: (each className category)) at: aDirectory.
			stream := directory forceNewFileNamed: each className ,'Methods.txt'.
			stream nextPutAll: each source.
			stream close"
			].
		]

	
"		stream := directory forceNewFileNamed: 'class.txt'.
		stream nextPutAll: (aVersion package snapshot definitions at:4)source.
		stream close.
		"! !

!McFdCreator methodsFor: 'creation' stamp: 'MU 11/21/2007 17:15'!
extractCategoryStringFrom: aString 
	^ (aString subStrings: '-') second.
! !

TestCase subclass: #McFdTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

McFdTestCase subclass: #McFdFilesystemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'pe 11/27/2007 12:12'!
testCreateCategoryDirectory
	| creator aDirectory packageDirectory versionDirectory |
	creator := McFdCreator new.
	aDirectory := FileDirectory default.
	packageDirectory := creator createDirectory: self packageName
				at: aDirectory.
	versionDirectory := creator createDirectory: self versionName
				at: packageDirectory.
	
	[creator createDirectory: self categoryName at: versionDirectory.
	self assert: (versionDirectory directoryExists: self categoryName)] 
			ensure: [packageDirectory recursiveDelete]! !

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'pe 11/27/2007 11:46'!
testCreateDirectory
	| dir creator aPackage |
	creator := McFdCreator new.
	dir := FileDirectory default.
	aPackage := MCPackage named: self packageName.
	
	[creator createDirectory: aPackage name at: dir.
	self assert: (dir directoryExists: aPackage name)] 
			ensure: [dir deleteDirectory: aPackage name]! !

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'pe 11/27/2007 12:10'!
testCreateVersionDirectory
	| creator aDirectory packageDirectory |
	creator := McFdCreator new.
	aDirectory := FileDirectory default.

	packageDirectory := creator createDirectory: self packageName at: aDirectory.
	
	[creator createDirectory: self versionName at: packageDirectory.
	self assert: (packageDirectory directoryExists: self versionName)
	] ensure: [packageDirectory recursiveDelete]
! !

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 17:07'!
testExtractCategoryString
	| creator aString resultString |
	aString := 'Spaet-Abends'.
	creator := McFdCreator new.
	resultString := creator extractCategoryStringFrom: aString.
	self assert: 'Abends' = resultString.
	! !

McFdTestCase subclass: #McFdPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdPackageTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 13:16'!
testCreateMethod
	(Smalltalk at: #McFdFooBar) methodDictionary at: #m1 ifAbsent: [self fail] 
	! !

!McFdPackageTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 13:16'!
testCreatePackage
	Smalltalk at: #McFdFooBar ifAbsent: [self fail].
	
	! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'pe 11/27/2007 12:08'!
categoryName
	^ 'Base'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'pe 11/27/2007 12:08'!
classCategoryName
	^ self packageName , '-' , self categoryName! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 15:07'!
packageName
	^ 'McFdFooBar'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 14:15'!
setUp
	Object 
		subclass: #McFdFooBar
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self classCategoryName.
	(Smalltalk at: #McFdFooBar) compile: 'm1 ^ 0'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 14:20'!
tearDown
	(Smalltalk at: #McFdFooBar) removeFromSystemUnlogged.
	
	Smalltalk organization removeCategory: self classCategoryName asSymbol! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'pe 11/27/2007 11:30'!
versionName
	^'McFdFooBar-wir.30'! !

McFdTestCase subclass: #McFdVersionInfoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdVersionInfoTest methodsFor: 'as yet unclassified' stamp: 'pe 11/27/2007 12:50'!
testWriteVersionToFile
	| expected aVersionInfo aDependencies aDirectory streamForVersionInfo |
	aVersionInfo := MCVersionInfo name: 'Versionname' id: '123' message: 'message' date: Date today time: Time noon author: 'wir' ancestors: #().
	aDependencies := #().
	aDirectory := FileDirectory default.
	
	streamForVersionInfo := aDirectory forceNewFileNamed: 'VersionInfo.txt'.
	streamForVersionInfo nextPutAll: '(name ''Versionname'' message ''message'' id ''123'' date ''23 November 2007'' time ''12:00 pm'' author ''wir'' ancestors () stepChildren ())'.
	streamForVersionInfo close.	
	
	[expected :=  '(name ''Versionname'' message ''message'' id ''123'' date ''23 November 2007'' time ''12:00 pm'' author ''wir'' ancestors () stepChildren ())'.
	self assert: (FileDirectory default fileExists: 'VersionInfo.txt').
	streamForVersionInfo := FileStream fileNamed: 'VersionInfo.txt'.
	self assert: (streamForVersionInfo contents = expected).	
	streamForVersionInfo close.]
		ensure: [FileDirectory default deleteFileNamed: 'VersionInfo.txt']! !
